#include "t8085.h"

TABLE dis_xx[256] = {
	{_tNOP,  _d0,	 _s0,	 0,	    _c0,    _x0},
	{_tLXI,	 _dBC,	 _sIMM16,0,	    _c0,    _x0},
	{_tSTAX, _dMBC,  _sA,	 0,	    _c0,    _x0},
	{_tINX,  _dBC,	 _sBC,	 0,	    _c0,    _x0},
	{_tINR,  _dB,	 _sB,	 _fSZHPN,   _c0,    _x0},
	{_tDCR,  _dB,	 _sB,	 _fSZHPN,   _c0,    _x0},
	{_tMVI,	 _dB,	 _sIMM8, 0,	    _c0,    _x0},
	{_tRLC,  _dA,	 _sA,	 0,	    _c0,    _x0},

	{_tDSUB, _dHL,	 _sDE,   0,	    _c0,    _x0},
	{_tDAD,  _dHL,	 _sBC,	 0,	    _c0,    _x0},
	{_tLDAX, _dA,	 _sMBC,  0,	    _c0,    _x0},
	{_tDCX,  _dBC,	 _sBC,	 0,	    _c0,    _x0},
	{_tINR,  _dC,	 _sC,	 _fSZHPN,   _c0,    _x0},
	{_tDCR,  _dC,	 _sC,	 _fSZHPN,   _c0,    _x0},
	{_tMVI,	 _dC,	 _sIMM8, 0,	    _c0,    _x0},
	{_tRRC,  _dA,	 _sA,	 0,	    _c0,    _x0},

	{_tARHL, _dHL,	 _s0,    0,	    _c0,    _x0},
	{_tLXI,	 _dDE,	 _sIMM16,0,	    _c0,    _x0},
	{_tSTAX, _dMDE,  _sA,	 0,	    _c0,    _x0},
	{_tINX,  _dDE,	 _sDE,	 0,	    _c0,    _x0},
	{_tINR,  _dD,	 _sD,	 _fSZHPN,   _c0,    _x0},
	{_tDCR,  _dD,	 _sD,	 _fSZHPN,   _c0,    _x0},
	{_tMVI,	 _dD,	 _sIMM8, 0,	    _c0,    _x0},
	{_tRAL,  _dA,	 _sA,	 0,	    _c0,    _x0},

	{_tRLDE, _dDE,	 _s0,    0,	    _c0,    _x0},
	{_tDAD,  _dHL,	 _sDE,	 0,	    _c0,    _x0},
	{_tLDAX, _dA,	 _sMDE,  0,	    _c0,    _x0},
	{_tDCX,  _dDE,	 _sDE,	 0,	    _c0,    _x0},
	{_tINR,  _dE,	 _sE,	 _fSZHPN,   _c0,    _x0},
	{_tDCR,  _dE,	 _sE,	 _fSZHPN,   _c0,    _x0},
	{_tMVI,	 _dE,	 _sIMM8, 0,	    _c0,    _x0},
	{_tRAR,  _dA,	 _sA,	 0,	    _c0,    _x0},

	{_tRIM,	 _dA,	 _sIM,   0,	    _cNZ,   _x0},
	{_tLXI,	 _dHL,	 _sIMM16,0,	    _c0,    _x0},
	{_tSHLD, _dIND16,_sHL,	 0,	    _c0,    _x0},
	{_tINX,  _dHL,	 _sHL,	 0,	    _c0,    _x0},
	{_tINR,  _dH,	 _sH,	 _fSZHPN,   _c0,    _x0},
	{_tDCR,  _dH,	 _sH,	 _fSZHPN,   _c0,    _x0},
	{_tMVI,	 _dH,	 _sIMM8, 0,	    _c0,    _x0},
	{_tDAA,  _dA,	 _sA,	 0,	    _c0,    _x0},

	{_tLDHI, _dDE,	 _sIMM8, 0,	    _cZ,    _x0},
	{_tDAD,  _dHL,	 _sHL,	 0,	    _c0,    _x0},
	{_tLHLD, _dHL,	 _sIND16,0,	    _c0,    _x0},
	{_tDCX,  _dHL,	 _sHL,	 0,	    _c0,    _x0},
	{_tINR,  _dL,	 _sL,	 _fSZHPN,   _c0,    _x0},
	{_tDCR,  _dL,	 _sL,	 _fSZHPN,   _c0,    _x0},
	{_tMVI,	 _dL,	 _sIMM8, 0,	    _c0,    _x0},
	{_tCMA,  _dA,	 _sA,	 0,	    _c0,    _x0},

	{_tSIM,	 _dIM,	 _sA,    0,	    _cNC,   _x0},
	{_tLXI,	 _dSP,	 _sIMM16,0,	    _c0,    _x0},
	{_tSTA,  _dIND8, _sA,	 0,	    _c0,    _x0},
	{_tINX,  _dSP,	 _sSP,	 0,	    _c0,    _x0},
	{_tINR,  _dM,	 _sM,	 _fSZHPN,   _c0,    _x0},
	{_tDCR,  _dM,	 _sM,	 _fSZHPN,   _c0,    _x0},
	{_tMVI,	 _dM,	 _sIMM8, 0,	    _c0,    _x0},
	{_tSTC,  _d0,	 _s0,	 0,	    _c0,    _x0},

	{_tLDSI, _dDE,	 _sIMM8, 0,	    _cC,    _x0},
	{_tDAD,  _dHL,	 _sSP,	 0,	    _c0,    _x0},
	{_tLDA,  _dA,	 _sIND8, 0,	    _c0,    _x0},
	{_tDCX,  _dSP,	 _sSP,	 0,	    _c0,    _x0},
	{_tINR,  _dA,	 _sA,	 _fSZHPN,   _c0,    _x0},
	{_tDCR,  _dA,	 _sA,	 _fSZHPN,   _c0,    _x0},
	{_tMVI,	 _dA,	 _sIMM8, 0,	    _c0,    _x0},
	{_tCCF,  _d0,	 _s0,	 0,	    _c0,    _x0},

	{_tMOV,	 _dB,	 _sB,	 0,	    _c0,    _x0},
	{_tMOV,	 _dB,	 _sC,	 0,	    _c0,    _x0},
	{_tMOV,	 _dB,	 _sD,	 0,	    _c0,    _x0},
	{_tMOV,	 _dB,	 _sE,	 0,	    _c0,    _x0},
	{_tMOV,	 _dB,	 _sH,	 0,	    _c0,    _x0},
	{_tMOV,	 _dB,	 _sL,	 0,	    _c0,    _x0},
	{_tMOV,	 _dB,	 _sM,	 0,	    _c0,    _x0},
	{_tMOV,	 _dB,	 _sA,	 0,	    _c0,    _x0},

	{_tMOV,	 _dC,	 _sB,	 0,	    _c0,    _x0},
	{_tMOV,	 _dC,	 _sC,	 0,	    _c0,    _x0},
	{_tMOV,	 _dC,	 _sD,	 0,	    _c0,    _x0},
	{_tMOV,	 _dC,	 _sE,	 0,	    _c0,    _x0},
	{_tMOV,	 _dC,	 _sH,	 0,	    _c0,    _x0},
	{_tMOV,	 _dC,	 _sL,	 0,	    _c0,    _x0},
	{_tMOV,	 _dC,	 _sM,	 0,	    _c0,    _x0},
	{_tMOV,	 _dC,	 _sA,	 0,	    _c0,    _x0},

	{_tMOV,	 _dD,	 _sB,	 0,	    _c0,    _x0},
	{_tMOV,	 _dD,	 _sC,	 0,	    _c0,    _x0},
	{_tMOV,	 _dD,	 _sD,	 0,	    _c0,    _x0},
	{_tMOV,	 _dD,	 _sE,	 0,	    _c0,    _x0},
	{_tMOV,	 _dD,	 _sH,	 0,	    _c0,    _x0},
	{_tMOV,	 _dD,	 _sL,	 0,	    _c0,    _x0},
	{_tMOV,	 _dD,	 _sM,	 0,	    _c0,    _x0},
	{_tMOV,	 _dD,	 _sA,	 0,	    _c0,    _x0},

	{_tMOV,	 _dE,	 _sB,	 0,	    _c0,    _x0},
	{_tMOV,	 _dE,	 _sC,	 0,	    _c0,    _x0},
	{_tMOV,	 _dE,	 _sD,	 0,	    _c0,    _x0},
	{_tMOV,	 _dE,	 _sE,	 0,	    _c0,    _x0},
	{_tMOV,	 _dE,	 _sH,	 0,	    _c0,    _x0},
	{_tMOV,	 _dE,	 _sL,	 0,	    _c0,    _x0},
	{_tMOV,	 _dE,	 _sM,	 0,	    _c0,    _x0},
	{_tMOV,	 _dE,	 _sA,	 0,	    _c0,    _x0},

	{_tMOV,	 _dH,	 _sB,	 0,	    _c0,    _x0},
	{_tMOV,	 _dH,	 _sC,	 0,	    _c0,    _x0},
	{_tMOV,	 _dH,	 _sD,	 0,	    _c0,    _x0},
	{_tMOV,	 _dH,	 _sE,	 0,	    _c0,    _x0},
	{_tMOV,	 _dH,	 _sH,	 0,	    _c0,    _x0},
	{_tMOV,	 _dH,	 _sL,	 0,	    _c0,    _x0},
	{_tMOV,	 _dH,	 _sM,	 0,	    _c0,    _x0},
	{_tMOV,	 _dH,	 _sA,	 0,	    _c0,    _x0},

	{_tMOV,	 _dL,	 _sB,	 0,	    _c0,    _x0},
	{_tMOV,	 _dL,	 _sC,	 0,	    _c0,    _x0},
	{_tMOV,	 _dL,	 _sD,	 0,	    _c0,    _x0},
	{_tMOV,	 _dL,	 _sE,	 0,	    _c0,    _x0},
	{_tMOV,	 _dL,	 _sH,	 0,	    _c0,    _x0},
	{_tMOV,	 _dL,	 _sL,	 0,	    _c0,    _x0},
	{_tMOV,	 _dL,	 _sM,	 0,	    _c0,    _x0},
	{_tMOV,	 _dL,	 _sA,	 0,	    _c0,    _x0},

	{_tMOV,	 _dM,	 _sB,	 0,	    _c0,    _x0},
	{_tMOV,	 _dM,	 _sC,	 0,	    _c0,    _x0},
	{_tMOV,	 _dM,	 _sD,	 0,	    _c0,    _x0},
	{_tMOV,	 _dM,	 _sE,	 0,	    _c0,    _x0},
	{_tMOV,	 _dM,	 _sH,	 0,	    _c0,    _x0},
	{_tMOV,	 _dM,	 _sL,	 0,	    _c0,    _x0},
	{_tHALT, _d0,	 _s0,	 0,	    _c0,    _x0},
	{_tMOV,	 _dM,	 _sA,	 0,	    _c0,    _x0},

	{_tMOV,	 _dA,	 _sB,	 0,	    _c0,    _x0},
	{_tMOV,	 _dA,	 _sC,	 0,	    _c0,    _x0},
	{_tMOV,	 _dA,	 _sD,	 0,	    _c0,    _x0},
	{_tMOV,	 _dA,	 _sE,	 0,	    _c0,    _x0},
	{_tMOV,	 _dA,	 _sH,	 0,	    _c0,    _x0},
	{_tMOV,	 _dA,	 _sL,	 0,	    _c0,    _x0},
	{_tMOV,	 _dA,	 _sM,	 0,	    _c0,    _x0},
	{_tMOV,	 _dA,	 _sA,	 0,	    _c0,    _x0},

	{_tADD,  _dA,	 _sB,	 _fSZHPNC,  _c0,    _x0},
	{_tADD,  _dA,	 _sC,	 _fSZHPNC,  _c0,    _x0},
	{_tADD,  _dA,	 _sD,	 _fSZHPNC,  _c0,    _x0},
	{_tADD,  _dA,	 _sE,	 _fSZHPNC,  _c0,    _x0},
	{_tADD,  _dA,	 _sH,	 _fSZHPNC,  _c0,    _x0},
	{_tADD,  _dA,	 _sL,	 _fSZHPNC,  _c0,    _x0},
	{_tADD,  _dA,	 _sM,	 _fSZHPNC,  _c0,    _x0},
	{_tADD,  _dA,	 _sA,	 _fSZHPNC,  _c0,    _x0},

	{_tADC,  _dA,	 _sB,	 _fSZHPNC,  _c0,    _x0},
	{_tADC,  _dA,	 _sC,	 _fSZHPNC,  _c0,    _x0},
	{_tADC,  _dA,	 _sD,	 _fSZHPNC,  _c0,    _x0},
	{_tADC,  _dA,	 _sE,	 _fSZHPNC,  _c0,    _x0},
	{_tADC,  _dA,	 _sH,	 _fSZHPNC,  _c0,    _x0},
	{_tADC,  _dA,	 _sL,	 _fSZHPNC,  _c0,    _x0},
	{_tADC,  _dA,	 _sM,	 _fSZHPNC,  _c0,    _x0},
	{_tADC,  _dA,	 _sA,	 _fSZHPNC,  _c0,    _x0},

	{_tSUB,  _dA,	 _sB,	 _fSZHPNC,  _c0,    _x0},
	{_tSUB,  _dA,	 _sC,	 _fSZHPNC,  _c0,    _x0},
	{_tSUB,  _dA,	 _sD,	 _fSZHPNC,  _c0,    _x0},
	{_tSUB,  _dA,	 _sE,	 _fSZHPNC,  _c0,    _x0},
	{_tSUB,  _dA,	 _sH,	 _fSZHPNC,  _c0,    _x0},
	{_tSUB,  _dA,	 _sL,	 _fSZHPNC,  _c0,    _x0},
	{_tSUB,  _dA,	 _sM,	 _fSZHPNC,  _c0,    _x0},
	{_tSUB,  _dA,	 _sA,	 _fSZHPNC,  _c0,    _x0},

	{_tSBB,  _dA,	 _sB,	 _fSZHPNC,  _c0,    _x0},
	{_tSBB,  _dA,	 _sC,	 _fSZHPNC,  _c0,    _x0},
	{_tSBB,  _dA,	 _sD,	 _fSZHPNC,  _c0,    _x0},
	{_tSBB,  _dA,	 _sE,	 _fSZHPNC,  _c0,    _x0},
	{_tSBB,  _dA,	 _sH,	 _fSZHPNC,  _c0,    _x0},
	{_tSBB,  _dA,	 _sL,	 _fSZHPNC,  _c0,    _x0},
	{_tSBB,  _dA,	 _sM,	 _fSZHPNC,  _c0,    _x0},
	{_tSBB,  _dA,	 _sA,	 _fSZHPNC,  _c0,    _x0},

	{_tANA,  _dA,	 _sB,	 _fSZHPNC,  _c0,    _x0},
	{_tANA,  _dA,	 _sC,	 _fSZHPNC,  _c0,    _x0},
	{_tANA,  _dA,	 _sD,	 _fSZHPNC,  _c0,    _x0},
	{_tANA,  _dA,	 _sE,	 _fSZHPNC,  _c0,    _x0},
	{_tANA,  _dA,	 _sH,	 _fSZHPNC,  _c0,    _x0},
	{_tANA,  _dA,	 _sL,	 _fSZHPNC,  _c0,    _x0},
	{_tANA,  _dA,	 _sM,	 _fSZHPNC,  _c0,    _x0},
	{_tANA,  _dA,	 _sA,	 _fSZHPNC,  _c0,    _x0},

	{_tXRA,  _dA,	 _sB,	 _fSZHPNC,  _c0,    _x0},
	{_tXRA,  _dA,	 _sC,	 _fSZHPNC,  _c0,    _x0},
	{_tXRA,  _dA,	 _sD,	 _fSZHPNC,  _c0,    _x0},
	{_tXRA,  _dA,	 _sE,	 _fSZHPNC,  _c0,    _x0},
	{_tXRA,  _dA,	 _sH,	 _fSZHPNC,  _c0,    _x0},
	{_tXRA,  _dA,	 _sL,	 _fSZHPNC,  _c0,    _x0},
	{_tXRA,  _dA,	 _sM,	 _fSZHPNC,  _c0,    _x0},
	{_tXRA,  _dA,	 _sA,	 _fSZHPNC,  _c0,    _x0},

	{_tORA,	 _dA,	 _sB,	 _fSZHPNC,  _c0,    _x0},
	{_tORA,	 _dA,	 _sC,	 _fSZHPNC,  _c0,    _x0},
	{_tORA,	 _dA,	 _sD,	 _fSZHPNC,  _c0,    _x0},
	{_tORA,	 _dA,	 _sE,	 _fSZHPNC,  _c0,    _x0},
	{_tORA,	 _dA,	 _sH,	 _fSZHPNC,  _c0,    _x0},
	{_tORA,	 _dA,	 _sL,	 _fSZHPNC,  _c0,    _x0},
	{_tORA,	 _dA,	 _sM,	 _fSZHPNC,  _c0,    _x0},
	{_tORA,	 _dA,	 _sA,	 _fSZHPNC,  _c0,    _x0},

	{_tCMP,	 _dA,	 _sB,	 _fSZHPNC,  _c0,    _x0},
	{_tCMP,	 _dA,	 _sC,	 _fSZHPNC,  _c0,    _x0},
	{_tCMP,	 _dA,	 _sD,	 _fSZHPNC,  _c0,    _x0},
	{_tCMP,	 _dA,	 _sE,	 _fSZHPNC,  _c0,    _x0},
	{_tCMP,	 _dA,	 _sH,	 _fSZHPNC,  _c0,    _x0},
	{_tCMP,	 _dA,	 _sL,	 _fSZHPNC,  _c0,    _x0},
	{_tCMP,	 _dA,	 _sM,	 _fSZHPNC,  _c0,    _x0},
	{_tCMP,	 _dA,	 _sA,	 _fSZHPNC,  _c0,    _x0},

	{_tRNZ,  _dPC,	 _sMSP,  0,	    _cNZ,   _x0},
	{_tPOP,  _dBC,	 _sMSP,  0,	    _c0,    _x0},
	{_tJNZ,	 _dPC,	 _sADR16,0,	    _cNZ,   _x0},
	{_tJMP,	 _dPC,	 _sADR16,0,	    _c0,    _x0},
	{_tCNZ,  _dPC,	 _sADR16,0,	    _cNZ,   _xPC},
	{_tPUSH, _dMSP,  _sBC,	 0,	    _c0,    _x0},
	{_tADI,  _dA,	 _sIMM8, _fSZHPNC,  _c0,    _x0},
	{_tRST,  _dPC,	 _sIMPL, 0,	    _c0,    _xPC},

	{_tRZ,   _dPC,	 _sMSP,  0,	    _cZ,    _x0},
	{_tRET,  _dPC,	 _sMSP,  0,	    _c0,    _x0},
	{_tJZ,	 _dPC,	 _sADR16,0,	    _cZ,    _x0},
	{_tRSTV, _dPC,	 _sIMPL, 0,	    _c0,    _x0},
	{_tCZ,   _dPC,	 _sADR16,0,	    _cZ,    _xPC},
	{_tCALL, _dPC,	 _sADR16,0,	    _c0,    _xPC},
	{_tACI,  _dA,	 _sIMM8, _fSZHPNC,  _c0,    _x0},
	{_tRST,  _dPC,	 _sIMPL, 0,	    _c0,    _xPC},

	{_tRNC,  _dPC,	 _sMSP,  0,	    _cNC,   _x0},
	{_tPOP,  _dDE,	 _sMSP,  0,	    _c0,    _x0},
	{_tJNC,	 _dPC,	 _sADR16,0,	    _cNC,   _x0},
	{_tOUT,  _dPORT8,_sA,	 0,	    _c0,    _x0},
	{_tCNC,  _dPC,	 _sADR16,0,	    _cNC,   _xPC},
	{_tPUSH, _dMSP,  _sDE,	 0,	    _c0,    _x0},
        {_tSUI,  _dA,    _sIMM8A,_fSZHPNC,  _c0,    _x0},
	{_tRST,  _dPC,	 _sIMPL, 0,	    _c0,    _xPC},

	{_tRC,   _dPC,	 _sMSP,  0,	    _cC,    _x0},
	{_tSHLX, _dDE,	 _sHL,	 0,	    _c0,    _x0},
	{_tJC,	 _dPC,	 _sADR16,0,	    _cC,    _x0},
	{_tIN,	 _dA,	 _sPORT8,0,	    _c0,    _x0},
	{_tCC,   _dPC,	 _sADR16,0,	    _cC,    _xPC},
	{_tJNX,  _dPC,	 _sADR16,0,	    _c0,    _x0},
	{_tSBI,  _dA,	 _sIMM8, _fSZHPNC,  _c0,    _x0},
	{_tRST,  _dPC,	 _sIMPL, 0,	    _c0,    _xPC},

	{_tRPO,  _dPC,	 _sMSP,  0,	    _cPO,   _x0},
	{_tPOP,  _dHL,	 _sMSP,  0,	    _c0,    _x0},
	{_tJPO,	 _dPC,	 _sADR16,0,	    _cPO,   _x0},
	{_tXTHL, _dMSP,  _sHL,	 0,	    _c0,    _x0},
	{_tCPO, _dPC,	 _sADR16,0,	    _cPO,   _xPC},
	{_tPUSH, _dMSP,  _sHL,	 0,	    _c0,    _x0},
	{_tANI,  _dA,	 _sIMM8, _fSZHPNC,  _c0,    _x0},
	{_tRST,  _dPC,	 _sIMPL, 0,	    _c0,    _xPC},

	{_tRPE,  _dPC,	 _sMSP,  0,	    _cPE,   _x0},
	{_tPCHL, _dPC,	 _sPCHL, 0,	    _c0,    _x0},
	{_tJPE,	 _dPC,	 _sADR16,0,	    _cPE,   _x0},
	{_tXCHG, _dDE,	 _sHL,	 0,	    _c0,    _x0},
	{_tCPE,  _dPC,	 _sADR16,0,	    _cPE,   _xPC},
	{_tLHLX, _dHL,	 _sDE,	 0,	    _c0,    _x0},
	{_tXRI,  _dA,	 _sIMM8, _fSZHPNC,  _c0,    _x0},
	{_tRST,  _dPC,	 _sIMPL, 0,	    _c0,    _xPC},

	{_tRP,   _dPC,	 _sMSP,  0,	    _cP,    _x0},
	{_tPOP,  _dAF,	 _sMSP,  _fALL,     _c0,    _x0},
	{_tJP,	 _dPC,	 _sADR16,0,	    _cP,    _x0},
	{_tDI,	 0,	 0,	 0,	    _c0,    _x0},
	{_tCP,   _dPC,	 _sADR16,0,	    _cP,    _xPC},
	{_tPUSH, _dMSP,  _sAF,	 0,	    _c0,    _x0},
	{_tORI,	 _dA,	 _sIMM8, _fSZHPNC,  _c0,    _x0},
	{_tRST,  _dPC,	 _sIMPL, 0,	    _c0,    _xPC},

	{_tRM,   _dPC,	 _sMSP,  0,	    _cM,    _x0},
	{_tSPHL, _dSP,	 _sHL,	 0,	    _c0,    _x0},
	{_tJM,	 _dPC,	 _sADR16,0,	    _cM,    _x0},
	{_tEI,	 0,	 0,	 0,	    _c0,    _x0},
	{_tCM,   _dPC,	 _sADR16,0,	    _cM,    _xPC},
        {_tJX,   _dPC,   _sADR16,0,	    _c0,    _x0},
        {_tCPI,  _dA,    _sIMM8, _fSZHPNC,  _c0,    _x0},
	{_tRST,  _dPC,	 _sIMPL, 0,	    _c0,    _xPC},
};
