typedef enum {
        _f0,            /* "none" */
        _fSZHPNC,       /* "Sign Zero Half-Carry Parity Negative Carry" */
        _fSZHPN,        /* "Sign Zero Half-Carry Parity Negative" */
        _fHNC,          /* "Half-Carry Negative Carry" */
        _fALL,          /* all flag bits */
}       CFLG;

typedef enum {
        _t0,            /*  0: "" */
        _tADD,          /*  1: "ADD" */
        _tADI,          /*  2: "ADI" */
        _tADC,          /*  3: "ADC" */
        _tACI,          /*  4: "ACI" */
        _tANA,          /*  5: "ANA" */
        _tANI,          /*  6: "ANI" */
        _tCNZ,          /*  7: "CNZ" */
        _tCZ,           /*  8: "CZ" */
        _tCNC,          /*  9: "CNC" */
        _tCC,           /* 10: "CC" */
        _tCPO,          /* 11: "CPO" */
        _tCPE,          /* 12: "CPE" */
        _tCP,           /* 13: "CP" */
        _tCM,           /* 14: "CM" */
        _tCALL,         /* 15: "CALL" */
        _tCCF,          /* 16: "CCF" */
        _tCMA,          /* 17: "CMA" */
        _tCMP,          /* 18: "CMP" */
        _tCPI,          /* 19: "CPI" */
        _tDAA,          /* 20: "DAA" */
        _tDCR,          /* 21: "DCR" */
        _tDCX,          /* 22: "DCX" */
        _tDI,           /* 23: "DI" */
        _tEI,           /* 24: "EI" */
        _tDAD,          /* 25: "DAD" */
        _tHALT,         /* 26: "HALT" */
        _tIN,           /* 27: "IN" */
        _tINX,          /* 28: "INX" */
        _tINR,          /* 29: "INR" */
        _tJNZ,          /* 30: "JNZ" */
        _tJZ,           /* 31: "JZ" */
        _tJNC,          /* 32: "JNC" */
        _tJC,           /* 33: "JC" */
        _tJPO,          /* 34: "JPO" */
        _tJPE,          /* 35: "JPE" */
        _tJP,           /* 36: "JP" */
        _tJM,           /* 37: "JM" */
        _tJMP,          /* 38: "JMP" */
        _tMOV,          /* 39: "MOV" */
        _tMVI,          /* 40: "MVI" */
        _tLXI,          /* 41: "LXI" */
        _tLDAX,         /* 42: "LDAX" */
        _tSTAX,         /* 43: "STAX" */
        _tLDA,          /* 44: "LDA" */
        _tSTA,          /* 45: "LDA" */
        _tLHLD,         /* 46: "LHLD" */
        _tSHLD,         /* 47: "SHLD" */
        _tNOP,          /* 48: "NOP" */
        _tORA,          /* 49: "ORA" */
        _tORI,          /* 50: "ORI" */
        _tOUT,          /* 51: "OUT" */
        _tPOP,          /* 52: "POP" */
        _tPUSH,         /* 53: "PUSH" */
        _tPCHL,         /* 54: "PCHL" */
        _tSPHL,         /* 55: "SPHL" */
        _tRNZ,          /* 56: "RNZ" */
        _tRZ,           /* 57: "RZ" */
        _tRNC,          /* 58: "RNC" */
        _tRC,           /* 59: "RC" */
        _tRPO,          /* 60: "RPO" */
        _tRPE,          /* 61: "RPE" */
        _tRP,           /* 62: "RP" */
        _tRM,           /* 63: "RM" */
        _tRET,          /* 64: "RET" */
        _tRLC,          /* 65: "RLC" */
        _tRRC,          /* 66: "RRC" */
        _tRAL,          /* 67: "RAL" */
        _tRAR,          /* 68: "RAR" */
        _tRST,          /* 69: "RST" */
        _tSBB,          /* 70: "SBB" */
        _tSBI,          /* 71: "SBI" */
        _tSTC,          /* 72: "STC" */
        _tSUB,          /* 73: "SUB" */
        _tSUI,          /* 74: "SUI" */
        _tXRA,          /* 75: "XRA" */
        _tXRI,          /* 76: "XRI" */
        _tXCHG,         /* 77: "XCHG" */
        _tXTHL,         /* 78: "XTHL" */
        _tRIM,          /* 79: "RIM" */
        _tSIM,          /* 80: "SIM" */
        _tDSUB,         /* 81: "DSUB" */
        _tARHL,         /* 82: "ARHL" */
        _tRLDE,         /* 83: "RLDE" */
        _tLDHI,         /* 84: "LDHI" */
        _tLDSI,         /* 85: "LDSI" */
        _tLHLX,         /* 86: "LHLX" */
        _tSHLX,         /* 87: "SHLX" */
        _tRSTV,         /* 88: "RSTV" */
        _tJNX,          /* 89: "JNX" */
        _tJX,           /* 90: "JX" */
        _tEXT           /* 91: "extended" */
}       OPER;

typedef enum {
        _d0,            /* 00: "" */
        _dB,            /* 01: "B" */
        _dC,            /* 02: "C" */
        _dD,            /* 03: "D" */
        _dE,            /* 04: "E" */
        _dH,            /* 05: "H" */
        _dL,            /* 06: "L" */
        _dM,            /* 07: "M" */
        _dA,            /* 08: "A" */
        _dIM,           /* 09: "IM" */
        _dMBC,          /* 10: "B" */
        _dMDE,          /* 11: "D" */
        _dMSP,          /* 12: "(SP)" */
        _dIND8,         /* 13: "(%w)" */
        _dIMM8,         /* 14: "%b" */
        _dPORT8,        /* 15: "(%b)" */
        _dBC,           /* 16: "B" */
        _dDE,           /* 17: "D" */
        _dHL,           /* 18: "H" */
        _dSP,           /* 19: "SP" */
        _dAF,           /* 20: "PSW" */
        _dPC,           /* 21: "$" */
        _dPCHL,         /* 22: "HL" */
        _dIND16,        /* 23: "(%w)" */
        _dIMPL          /* 24: "?" */
}       DST;

typedef enum {
        _s0,            /* 00: "" */
        _sB,            /* 01: "B" */
        _sC,            /* 02: "C" */
        _sD,            /* 03: "D" */
        _sE,            /* 04: "E" */
        _sH,            /* 05: "H" */
        _sL,            /* 06: "L" */
        _sM,            /* 07: "M" */
        _sA,            /* 08: "A" */
        _sIM,           /* 09: "IM" */
        _sMBC,          /* 10: "B" */
        _sMDE,          /* 11: "D" */
        _sMSP,          /* 12: "(SP)" */
        _sIND8,         /* 13: "(%w)" */
        _sIMM8,         /* 14: "%b" */
        _sIMM8A,	/* 15: "%b" */
        _sPORT8,        /* 16: "(%b)" */
        _sBC,           /* 17: "B" */
        _sDE,           /* 18: "D" */
        _sHL,           /* 19: "H" */
        _sSP,           /* 20: "SP" */
        _sAF,           /* 21: "PSW" */
        _sPC,           /* 22: "$" */
        _sPCHL,         /* 23: "HL" */
        _sIMM16,        /* 24: "%w" */
	_sADR16,	/* 25: "%w" */
        _sIND16,        /* 26: "(%w)" */
        _sIMPL          /* 27: "?" */
}       SRC;

typedef enum {
        _c0,            /* 00: "" */
        _cNZ,           /* 01: "NZ" */
        _cZ,            /* 02: "Z" */
        _cNC,           /* 03: "NC" */
        _cC,            /* 04: "C" */
        _cPO,           /* 05: "PO" */
        _cPE,           /* 06: "PE" */
        _cP,            /* 07: "P" */
        _cM             /* 08: "M" */
}       COND;

typedef enum {
        _x0,            /* 00: "" */
        _xPC            /* 01: "(--SP)<-PC" */
}       SPEC;

typedef struct {
        OPER oper:8;
        DST dst:8;
        SRC src:8;
	COND cond:5;
        CFLG cflg:4;
        SPEC spec:7;
} TABLE;

extern TABLE dis_xx[256];
